/*
	A simple 2D figure rotating

	Fraga 19/11/2000
 */


#include <stdio.h>
#include <GL/glut.h>

float angle=5.0;

void display(void)
{
	/* clear all pixels  */
	glClear (GL_COLOR_BUFFER_BIT);

	// glMatrixMode(GL_MODELVIEW);

	/* draw a red polygon **/
	glColor3f (1.0, 0.0, 0.0);

	// glPushMatrix( );
	glTranslatef( 0.5, 0.5, 0.0 );	
	glRotatef( angle, 0.0, 0.0, 1.0);
	// glPopMatrix( );

	glBegin(GL_POLYGON);
		glVertex3f (-0.25,-0.25, 0.0);
		glVertex3f (-0.25, 0.25, 0.0);
		glVertex3f ( 0.25, 0.25, 0.0);
	glEnd();
	glTranslatef(-0.5,-0.5, 0.0 );	

	glutSwapBuffers();

	// glFlush ();
}

void init (void)
{
	/* select clearing color 	*/
	glClearColor (1.0, 1.0, 1.0, 0.0);

	/* initialize viewing values  */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// gluOrtho2D(0.0, 1.0, 0.0, 1.0);
	glOrtho(0.0, 1.0, 0.0, 1.0, -1.0, 10.0);
}

static void
key(unsigned char k, int x, int y)
{
	switch (k) {
		case 27:  /* Escape */
			exit(0);
			break;
		case 'n':
			break;
		case 'f':
			angle = -5.0;
			return;
		case 'b':
			angle =  5.0;
			return;
		default:
			return;
	}
	glutPostRedisplay();
}

static void idle( void )
{
	static int lastTime = 0;
	int time = glutGet( GLUT_ELAPSED_TIME );

	if ( lastTime == 0 ) 
		lastTime = time;
	else if ( time - lastTime < 100 ) /* 50Hz update **/	
		return;

	lastTime = time;

	glutPostRedisplay( );
}
/*
 * Declare initial window size, position, and display mode
 * (single buffer and RGBA).  Open window with "hello"
 * in its title bar.  Call initialization routines.
 * Register callback function to display graphics.
 * Enter main loop and process events.
 */
int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize (250, 250);
	glutInitWindowPosition (100, 100);
	glutCreateWindow ( argv[0] );
	init ();
	glutDisplayFunc(display);
	glutKeyboardFunc(key);
	glutIdleFunc( idle );

	glutMainLoop();
	return 0;   /* ANSI C requires main to return int. */
}
